Imports Core

Module Game

    ' goes through Survivors list and each people list of the buildings
    ' and returns the number of living survivors
    Public Function GetTotalSurvivors() As Integer
        Dim Total As Integer
        Dim bInfo As BuildingInfo, control As Control

        Total += Survivors.Count
        For Each control In frmMain.pn_Property.Controls
            bInfo = control.Tag
            Total += bInfo.People.Count
        Next

        Return Total
    End Function

    ' goes through survivors in raiding party and buildings and adds
    ' their total hours (.Experience) together. Only really used
    ' to compute the score
    Public Function GetSurvivorHours() As Integer
        Dim Total As Integer
        Dim bInfo As BuildingInfo, control As Control

        For Each survivor As Person In Survivors
            Total += survivor.Experience
        Next
        For Each control In frmMain.pn_Property.Controls
            bInfo = control.Tag
            For Each survivor As Person In bInfo.People
                Total += survivor.Experience
            Next
        Next

        Return Total
    End Function

    ' unused, but goes through current survivors everywhere
    ' and returns the total infected
    Public Function GetSurvivorsInfected() As Integer
        Dim Total As Integer
        Dim bInfo As BuildingInfo, control As Control

        For Each survivor As Person In Survivors
            If survivor.Infected = True Then
                Total += 1
            End If
        Next

        For Each control In frmMain.pn_Property.Controls
            bInfo = control.Tag
            For Each survivor As Person In bInfo.People
                If survivor.Infected = True Then
                    Total += 1
                End If
            Next
        Next

        Return Total
    End Function

    ' number of buildings current secured
    Public Function GetBuildingsHeld() As Integer
        Dim bHeld As Integer
        For Each Control As Control In frmMain.pn_Property.Controls
            Dim bInfo As BuildingInfo = Control.Tag
            If bInfo.Secured = True Then
                bHeld += 1
            End If
        Next

        Return bHeld
    End Function

    ' returns a formatted list of people in a Person array
    Public Function GetPeopleAsString(ByVal Peeps As Generic.List(Of Person)) As String
        Dim peep As Person, i As Integer = 1
        Dim returnString As String = ""

        For Each peep In Peeps
            Dim FirstName As String = peep.Name
            If i = Peeps.Count Then
                returnString &= FirstName
            ElseIf i = (Peeps.Count - 1) Then
                returnString &= FirstName & " and "
            Else
                returnString &= FirstName & ", "
            End If
            i += 1
        Next

        Return returnString
    End Function

    ' calculates the end score
    Public Function CalculateScore() As Integer
        Dim Score As Integer

        Score += (GetTotalSurvivors() * 50)
        Score += (GetBuildingsHeld() * 100)
        Score += (GetSurvivorHours() * 2)
        Score += (ZombiesKilled)

        Score -= (SurvivorsLost * 25)
        Score -= (SurvivorsTurned * 35)
        Score -= (GetSurvivorsInfected() * 5)

        Return Score
    End Function

End Module
