Imports Core

Public Class frmEncounter

    ' rounds vs virtual rounds
    ' when we raid, we always want the survivors to do a certain number of sweeps
    ' so, while the round counter keeps going up for the [time] prefix, our virtual
    ' rounds only count up when we don't have combat. virtual rounds only used for
    ' raiding, though you could use them to force the player to do ten rounds
    ' in an unsecured building instead of securing it straight after and encounter

    Private Round As Integer = 1
    Private VirtualRounds As Integer = 1
    Private EncounterCompleted As Boolean
    Private SharpEyeBonus As Integer
    Private HomeBonus As Integer

    Private RewardsCount As Integer

    Private WhosAttack As Boolean
    Private DoFight As Boolean
    Private NumberOfZombies As Integer, ZombieHP As Integer
    Private DidFight As Boolean

    Private Sub Done_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Done.Click
        Me.Dispose()
        frmEvents.Focus()
    End Sub

    Private Sub frmEncounter_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' pre-calculate the sharpeye bonus
        If SelectedEncounter.EventType = EventTypes.Raid Then
            Dim Peep As Person

            For Each Peep In SelectedEncounter.Building.People
                If Peep.Promo_SharpEye Then SharpEyeBonus += 2
            Next
        End If

        ExecuteEvent()
        btn_NextRound.Focus()
        NextRoundTick.Enabled = True
    End Sub

    Private Function RoundAsTime() As String
        Dim RoundMinute As String, RoundHour As String, RoundSecond As String

        RoundHour = Int(Round / 60)
        If RoundHour < 10 Then
            RoundHour = "0" & RoundHour & ":"
        Else
            RoundHour = RoundHour & ":"
        End If

        Dim rdiv As Integer = Int((Round / 60)) * 60
        RoundMinute = Round - rdiv
        If RoundMinute < 10 Then
            RoundMinute = "0" & RoundMinute & ":"
        Else
            RoundMinute = RoundMinute & ":"
        End If

        RoundSecond = Rnd.Next(0, 45)
        If RoundSecond < 10 Then
            RoundSecond = "0" & RoundSecond
        Else
            RoundSecond = RoundSecond
        End If

        Return "[" & RoundHour & RoundMinute & RoundSecond & "] "
    End Function

    Private Function PerformSuccessfulRaid() As String

        ' okay, so here's where all the raid stuff happens. you can tweak the chances of finding stuff
        ' the stuff you can find - most raid stuff - in this routine
        ' we used the RaidPriority vars to find out what the player wants most
        ' Base chances are: RP 1 = 70%, RP 2 = 20%, RP 3 = 10% (as of v1.5)

        Dim doneString As String = ""
        Dim RewardChance As Integer = Rnd.Next(1, 100)
        Dim Which As Integer = Rnd.Next(5)

        If ifChanceWithin(RewardChance, RaidPriority_Weapons) Then
            Dim WeaponsAvailable(7) As WeaponType
            Dim WhichWeapon As Integer = RND.Next(1, 8)
            WeaponsAvailable(1) = Bat()
            WeaponsAvailable(2) = Machete()
            WeaponsAvailable(3) = Pistol()
            WeaponsAvailable(4) = Pistol()
            WeaponsAvailable(5) = Rifle()
            WeaponsAvailable(6) = Rifle()
            WeaponsAvailable(7) = Shotgun()

            Weapons.Add(WeaponsAvailable(WhichWeapon))

            doneString &= "A " & WeaponsAvailable(WhichWeapon).Name & " was found in the back of a truck. "

        ElseIf ifChanceWithin(RewardChance, RaidPriority_Survivors) Then
            Dim survivor As Person = GenerateNewPerson()
            SelectedEncounter.Building.People.Add(survivor)
            doneString &= survivor.Name & " was rescued from their home. "

        ElseIf ifChanceWithin(RewardChance, RaidPriority_AmmoSupplies) Then

            If Which <= 2 Then
                Ammo += RaidBonus_Ammo
                doneString &= "Boxes of ammunition have been discovered inside a car boot. "
            Else
                Supplies += RaidBonus_Supplies
                doneString &= "The party has scavenged metal from a smashed car for use in barricades. "
            End If

        ElseIf ifChanceWithin(RewardChance, RaidPriority_MedicineWater) Then

            If Which <= 3 Then
                Water += RaidBonus_Water
                doneString &= "The party has taken bottles of water from a convenience store. "
            Else
                Medicine += RaidBonus_Medicine
                doneString &= "A first aid kit was found in a crumpled box. "
            End If
        End If

        ' make sure the player doesn't find more resources than the number of survivors in the raiding party.
        RewardsCount += 1

        Return doneString
    End Function

    Private Function ifChanceWithin(ByVal chance As Integer, ByVal rewardType As Integer)
        If chance >= Priorities(rewardType, 0) And chance <= Priorities(rewardType, 1) Then
            Return True
        End If

        Return False
    End Function

    Private Sub ExecuteEvent()

        Dim RoundString As String = RoundAsTime()

        Dim Moves As String = "approaches"

        If SelectedEncounter.Building.People.Count > 1 Then
            Moves = "approach"
        End If

        Select Case SelectedEncounter.EventType
            Case EventTypes.Attacked_Outside
                If Round = 1 Then
                    RoundString &= GetPeopleAsString(SelectedEncounter.Building.People)
                    If FinalHour() Then
                        NumberOfZombies = 20 + ((ZombieParty() * 0.45) * (6 - GetBuildingsHeld()))
                        RoundString &= " try to find cover as " & NumberOfZombies & " zombie(s) approach them from the outskirts of town. "
                    Else
                        NumberOfZombies = ZombieParty()
                        RoundString &= " try to find cover as " & NumberOfZombies & " zombie(s) approach them from the darkness. "
                    End If
                    DoFight = True
                ElseIf DoFight Then
                    RoundString &= DoCombat()
                End If
            Case EventTypes.Raid
                If Round = 1 Then
                    RoundString &= GetPeopleAsString(SelectedEncounter.Building.People)
                    RoundString &= " venture from the town centre in search of supplies. "
                Else
                    Dim FindAZombie As Integer = Rnd.Next(1, 100)
                    If DoFight Then
                        RoundString &= DoCombat()
                    ElseIf FindAZombie < ZombieChance() And DidFight = False Then
                        NumberOfZombies = ZombieParty() * 0.66
                        If NumberOfZombies = 0 Then NumberOfZombies = 1
                        RoundString &= "The party has encountered " & NumberOfZombies & " zombie(s)!"

                        DoFight = True
                    ElseIf VirtualRounds = 8 Then
                        EncounterCompleted = True
                        DoFight = False
                        RoundString &= "The party has finished their sweep. "
                    Else
                        Dim Chance As Integer = Rnd.Next(1, 100)
                        Dim BaseFindChance As Integer = 45 + SharpEyeBonus
                        If Chance <= BaseFindChance And RewardsCount < SelectedEncounter.Building.People.Count Then
                            RoundString &= PerformSuccessfulRaid()
                        Else
                            RoundString &= "A few moments of searching turn up nothing. "
                        End If
                        VirtualRounds += 1
                    End If
                End If
            Case EventTypes.Attacked_Building
                If Round = 1 Then
                    If SelectedEncounter.Building.People.Count = 0 Then
                        RoundString &= "The zombies overrun the undefended structure! "
                        EncounterCompleted = True
                    Else
                        HomeBonus = GetHomeBonus(SelectedEncounter.Building)
                        If NightAssaultSuccess Then
                            NumberOfZombies = Math.Round(NumberOfZombies * 0.75, 0)
                            NightAssaultSuccess = False
                        End If
                        NumberOfZombies = ZombieParty()
                        If NumberOfZombies < 0 Then NumberOfZombies = 0

                        RoundString &= GetPeopleAsString(SelectedEncounter.Building.People)
                        If SelectedEncounter.Building.People.Count = 1 Then
                            RoundString &= " watches as " & NumberOfZombies & " zombie(s) approach the " & SelectedEncounter.Building.Name & ". "
                        Else
                            RoundString &= " watch as " & NumberOfZombies & " zombie(s) approach the " & SelectedEncounter.Building.Name & ". "
                        End If

                        If HomeBonus > 0 Then
                            RoundString &= " The survivors are able to pick off " & HomeBonus & " zombie(s) before they reach the building. "
                            NumberOfZombies -= HomeBonus
                        End If
                    End If
                Else
                    RoundString &= DoCombat()
                End If

            Case EventTypes.Secure_Building
                If Round = 1 Then
                    RoundString &= GetPeopleAsString(SelectedEncounter.Building.People)
                    RoundString &= " " & Moves & " the " & SelectedEncounter.Building.Name & "."
                ElseIf Round = 2 Then
                    Dim EntryType As Integer = Rnd.Next(1, 3)
                    Select Case EntryType
                        Case 1
                            RoundString &= "The front door is unlocked, the party has entered the building."
                        Case 2
                            RoundString &= "An opened window on the ground floor provides easy access. The party is now inside."
                        Case 3
                            RoundString &= "After climbing the roof, the party enters via an upstairs window."
                    End Select
                ElseIf DoFight Then
                    RoundString &= DoCombat()
                ElseIf Round = 10 Then
                    RoundString &= "The building is now clear and has been secured."
                    EncounterCompleted = True
                Else
                    Dim FindAZombie As Integer = Rnd.Next(1, 100)
                    If FindAZombie < ZombieChance() Then
                        NumberOfZombies = ZombieParty() / 2
                        If NumberOfZombies = 0 Then NumberOfZombies = 1
                        RoundString &= "The party has encountered " & NumberOfZombies & " zombie(s)!"

                        DoFight = True
                    Else
                        RoundString &= "No encounters, looks clear so far."
                    End If

                End If

        End Select

        tb_Log.Text &= RoundString & vbCrLf
        Round += 1
    End Sub

    Private Function GetHomeBonus(ByVal Building As BuildingInfo) As Integer
        Dim Bonus As Integer = 0

        For Each Peep As Person In Building.People
            If Peep.Promo_Home = True Then
                Bonus += 1
            End If
        Next

        Return Bonus
    End Function

    Private Function DoCombat() As String
        Dim ResultString As String = "" '        RoundAsTime()
        DidFight = True

        If WhosAttack = False Then
            Dim Peep As Person

            For Each Peep In SelectedEncounter.Building.People

                If SelectedEncounter.EventType = EventTypes.Attacked_Building And SelectedEncounter.Building.Reinforcement > 1 _
                And (Peep.Weapon.IsMelee = True Or (Peep.Weapon.IsMelee = False And Peep.Ammo = 0)) Then
                    ResultString &= Peep.Name & " waits by the building's entry in case zombies break in. "
                    ResultString &= vbCrLf
                Else
                    Dim VerbAttack As String = "hits ", WeaponName As String

                    Dim AmmoToFire As Integer = Peep.Weapon.AmmoNeed
                    If Peep.Promo_Conserve Then
                        AmmoToFire -= 1
                    End If

                    Select Case Peep.Weapon.IsMelee
                        Case True
                            VerbAttack = " swings"
                        Case False
                            If Peep.Ammo >= AmmoToFire Then
                                VerbAttack = " fires"
                            Else
                                VerbAttack = " whips"
                            End If
                    End Select

                    WeaponName = Peep.Weapon.Name.ToLower
                    If Peep.Weapon.IsMelee = False And Peep.Ammo = 0 Then
                        WeaponName = "empty " & WeaponName
                    End If

                    If Peep.Starved = True Then
                        ResultString &= Peep.Name & " is too weak from thirst to fight. "
                        ResultString &= vbCrLf
                    Else
                        ResultString &= Peep.Name & VerbAttack & " at a zombie with their " & WeaponName & ". The zombie stumbles. "
                        ResultString &= vbCrLf

                        If Peep.Weapon.IsMelee = False And Peep.Ammo < AmmoToFire Then
                            ZombieHP += 1
                        Else
                            ZombieHP += Peep.Weapon.Damage
                        End If

                        If Peep.Promo_SteadyHand Then
                            ZombieHP += 1
                        End If

                        If ZombieHP >= 6 Then
                            NumberOfZombies -= 1
                            ZombieHP = (ZombieHP - 6)
                            ResultString &= "A zombie collapses to the ground. "
                            ZombiesKilled += 1
                            If NumberOfZombies > 0 Then
                                ResultString &= NumberOfZombies & " zombie(s) left. "
                            End If
                            ResultString &= vbCrLf
                        End If

                        If NumberOfZombies = 0 Then
                            ResultString &= "That seems to be the last one."
                            If ZombieMass > ZombieMassMinimum Then
                                ZombieMass -= 1
                            End If

                            If SelectedEncounter.EventType <> EventTypes.Raid Then EncounterCompleted = True
                            DoFight = False
                            Exit For
                        End If
                    End If
                End If

            Next
        Else
            If SelectedEncounter.EventType = EventTypes.Attacked_Building And SelectedEncounter.Building.Reinforcement > 0 Then
                SelectedEncounter.Building.Reinforcement -= 1
                If SelectedEncounter.Building.Reinforcement = 0 Then
                    ResultString &= "The fortifications have failed, zombies are pouring into the building! "
                Else
                    ResultString &= "The zombies smash their fists against the building's fortifications. "

                    Select Case SelectedEncounter.Building.Reinforcement
                        Case Is <= 5
                            ResultString &= "The barricades are about to collapse. "
                        Case Is <= 10
                            ResultString &= "The barricades are failing. "
                        Case Is <= 15
                            ResultString &= "The barricades are breaking down. "
                        Case Is <= 20
                            ResultString &= "The barricades are holding. "
                        Case Is < 25
                            ResultString &= "The barricades are hardly damaged. "
                        Case Is >= 25
                            ResultString &= "The building is well-fortified. "
                    End Select

                End If
            Else
                Dim z As Integer, Shambling As Boolean = False
                For z = 1 To NumberOfZombies
                    If SelectedEncounter.Building.People.Count = 0 Then Exit For
                    Dim WhoToBite As Integer = Rnd.Next(0, SelectedEncounter.Building.People.Count - 1)
                    Dim Target As Person = SelectedEncounter.Building.People(WhoToBite)

                    Dim Bitten As Integer = Rnd.Next(1, 100)
                    Dim Infected As Integer = Rnd.Next(1, 100)

                    Dim BittenModifier As Integer = 0
                    If Target.Weapon.IsMelee = False And Target.Ammo > 0 Then
                        BittenModifier = 30
                    Else
                        If Target.Weapon.Name <> "Fists" Then
                            BittenModifier = 10
                        End If
                    End If

                    If Target.Promo_Grizzled Then
                        BittenModifier += 10
                    End If

                    If Bitten <= (MeleeBiteChance - BittenModifier) Then
                        ResultString &= Target.Name & " has been bitten by a zombie and "
                        Target.Wounds += 1
                        Select Case Target.Wounds
                            Case 1
                                ResultString &= "is injured. "
                            Case 2
                                ResultString &= "has grevious wounds. "
                            Case Is > 2
                                If Target.Promo_Lucky And Target.Wounds = 3 Then
                                    ResultString &= "is critically injured, but fights the pain. "
                                Else
                                    ResultString &= "has died. "
                                    Target.Dead = True
                                    SelectedEncounter.DeadPeople.Add(Target)
                                    SelectedEncounter.Building.People.Remove(Target)
                                    SurvivorsLost += 1
                                    If Target.Infected = True Then
                                        SurvivorsLost -= 1
                                        SurvivorsTurned += 1
                                        ResultString &= Target.Name & "'s corpse comes back to life!"
                                        NumberOfZombies += 1
                                    End If
                                End If
                        End Select
                        If Infected <= MeleeInfectionRisk And Target.Dead = False Then
                            ResultString &= "The wound burns. "
                            Target.Infected = True
                        End If
                        ResultString &= vbCrLf
                    Else
                        If Shambling = False Then
                            ResultString &= "The zombies shamble about. "
                            ResultString &= vbCrLf
                            Shambling = True
                        End If
                    End If
                Next
            End If

            If SelectedEncounter.Building.People.Count = 0 Then
                ResultString &= "You have lost contact with the party. "
                EncounterCompleted = True
            End If
        End If

        WhosAttack = Not (WhosAttack)
        Return ResultString
    End Function

    Private Sub btn_NextRound_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_NextRound.Click
        NextRoundTick.Interval = 10
    End Sub

    ' resources found while securing a building, separate from (and has nothing to do with) raid code.
    Private Function FindResources() As String
        Dim resourceString As String = ""
        Dim survivorChance As Integer = 10
        Dim suppliesChance As Integer = 10
        Dim waterChance As Integer = 10
        Dim ammoChance As Integer = 10
        Dim weaponChance As Integer = 10
        Dim medicineChance As Integer = 10

        Select Case SelectedEncounter.Building.Name
            Case "Warehouse"
                suppliesChance = 20
                ammoChance = 12
            Case "Store"
                waterChance = 20
                survivorChance = 12
            Case "Factory"
                ammoChance = 20
                suppliesChance = 12
            Case "Mansion"
                survivorChance = 30
            Case "Hospital"
                medicineChance = 20
                survivorChance = 12
            Case "House"
                suppliesChance = 12
                ammoChance = 12
                medicineChance = 12
                survivorChance = 12
                waterChance = 12
                weaponChance = 12
        End Select

        Dim survivorResult As Integer = Rnd.Next(1, 100)
        Dim suppliesResult As Integer = Rnd.Next(1, 100)
        Dim waterResult As Integer = Rnd.Next(1, 100)
        Dim ammoResult As Integer = Rnd.Next(1, 100)
        Dim weaponResult As Integer = Rnd.Next(1, 100)
        Dim medicineResult As Integer = Rnd.Next(1, 100)

        resourceString = "The party found: "
        If survivorResult <= survivorChance Then
            Dim survivor As Person = GenerateNewPerson()
            survivor.Wounds = RND.Next(2)
            SelectedEncounter.Building.People.Add(survivor)
            If survivor.Wounds = 0 Then
                resourceString &= "A survivor, "
            Else
                resourceString &= "An injured survivor, "
            End If
            resourceString &= survivor.Name & ". "
        End If

        If suppliesResult <= suppliesChance Then
            Supplies += 2
            resourceString &= "Some barracading supplies. "
        End If

        If waterResult <= waterChance Then
            Water += 3
            resourceString &= "A few litres of fresh water. "
        End If

        If ammoResult <= ammoChance Then
            Ammo += 3
            resourceString &= "A box of ammunition. "
        End If

        If weaponResult <= weaponChance Then
            Weapons.Add(Pistol())
            resourceString &= "A pistol in a locker. "
        End If

        If medicineResult <= medicineChance Then
            Medicine += 1
            resourceString &= "Some bandages and antibiotics. "
        End If

        If resourceString = "The party found: " Then resourceString = ""

        Return resourceString
    End Function

    Private Sub NextRoundTick_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextRoundTick.Tick
        ExecuteEvent()

        If EncounterCompleted Then
            btn_NextRound.Enabled = False
            NextRoundTick.Enabled = False
            btn_Done.Enabled = True
            btn_Done.Focus()

            If SelectedEncounter.EventType = EventTypes.Secure_Building Then
                If SelectedEncounter.Building.People.Count = 0 Then
                    SelectedEncounter.Failed = True
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.DeadPeople) & _
                    " died attempting to secure the " & SelectedEncounter.Building.Name & "."
                ElseIf SelectedEncounter.Building.People.Count > 0 And SelectedEncounter.DeadPeople.Count > 0 Then
                    SelectedEncounter.Building.Secured = True
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.Building.People) & _
                    " successfully secured the " & SelectedEncounter.Building.Name & ". However, " & _
                    GetPeopleAsString(SelectedEncounter.DeadPeople) & " died in the process."
                Else
                    SelectedEncounter.Building.Secured = True
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.Building.People) & _
                    " successfully secured the " & SelectedEncounter.Building.Name & "."
                End If
            ElseIf SelectedEncounter.EventType = EventTypes.Attacked_Building Then
                If SelectedEncounter.Building.People.Count = 0 And SelectedEncounter.DeadPeople.Count > 0 Then
                    SelectedEncounter.Failed = True
                    SelectedEncounter.Building.Secured = False
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.DeadPeople) & _
                    " died attempting to defend the " & SelectedEncounter.Building.Name & "."
                ElseIf SelectedEncounter.Building.People.Count > 0 And SelectedEncounter.DeadPeople.Count > 0 Then
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.Building.People) & _
                    " successfully defended the " & SelectedEncounter.Building.Name & ". However, " & _
                    GetPeopleAsString(SelectedEncounter.DeadPeople) & " died in the process."
                ElseIf SelectedEncounter.Building.People.Count = 0 And SelectedEncounter.DeadPeople.Count = 0 Then
                    SelectedEncounter.Failed = True
                    SelectedEncounter.Building.Secured = False
                    SelectedEncounter.ResolvedDescription = "Left undefended, the " & SelectedEncounter.Building.Name & " was " & _
                    "overrun by zombies."
                Else
                    tb_Log.Text &= RoundAsTime() & "The building was defended without casualties."
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.Building.People) & _
                    " successfully defended the " & SelectedEncounter.Building.Name & "."
                End If

            ElseIf SelectedEncounter.EventType = EventTypes.Attacked_Outside Then
                If SelectedEncounter.Building.People.Count = 0 And SelectedEncounter.DeadPeople.Count > 0 Then
                    SelectedEncounter.Failed = True
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.DeadPeople) & _
                    " died while fending off zombies in an outdoor assault. "
                ElseIf SelectedEncounter.Building.People.Count > 0 And SelectedEncounter.DeadPeople.Count > 0 Then
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.Building.People) & _
                    " successfully protected themselves from an outdoor attack. " & SelectedEncounter.Building.Name & "However, " & _
                    GetPeopleAsString(SelectedEncounter.DeadPeople) & " died in the process."
                    NightAssaultSuccess = True
                Else
                    tb_Log.Text &= RoundAsTime() & "The party has successfully protected itself."
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.Building.People) & _
                    " successfully defended themselves during an outdoor assualt."
                    NightAssaultSuccess = True
                End If

            ElseIf SelectedEncounter.EventType = EventTypes.Raid Then
                If SelectedEncounter.Building.People.Count = 0 And SelectedEncounter.DeadPeople.Count > 0 Then
                    SelectedEncounter.Failed = True
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.DeadPeople) & _
                    " died while searching for resources."
                ElseIf SelectedEncounter.Building.People.Count > 0 And SelectedEncounter.DeadPeople.Count > 0 Then
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.Building.People) & _
                    " completed a search for resources. However, " & _
                    GetPeopleAsString(SelectedEncounter.DeadPeople) & " died in the process."
                Else
                    SelectedEncounter.ResolvedDescription = GetPeopleAsString(SelectedEncounter.Building.People) & _
                    " completed a search for supplies without serious incident."
                End If

            End If

            If DidFight = True Then
                Dim peep As Person
                For Each peep In SelectedEncounter.Building.People
                    If peep.Weapon.IsMelee = False Then
                        Dim AmmoToFire As Integer = peep.Weapon.AmmoNeed
                        If peep.Promo_Conserve Then
                            AmmoToFire -= 1
                        End If

                        If peep.Ammo >= peep.Weapon.AmmoNeed Then
                            peep.Ammo -= AmmoToFire
                        End If
                    End If
                Next
            End If

            If SelectedEncounter.Failed = False Then
                If SelectedEncounter.EventType = EventTypes.Secure_Building Then
                    tb_Log.Text &= vbCrLf & FindResources()
                End If
            End If

        Else
            btn_NextRound.Focus()
        End If

        tb_Log.SelectionStart = tb_Log.Text.Length
        tb_Log.ScrollToCaret()
        tb_Log.SelectionLength = 0
    End Sub
End Class