Imports Core

Public Class frmEvents

    Private Encounters As New Generic.List(Of EncounterItem)

    Private Sub frmEvents_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SecureBuildings()
        RaidingParty()

        Dim AttackThisHour As Integer = Rnd.Next(1, 100)
        If AttackThisHour <= ZombieChance() Then
            ZombieAttacks()
        End If

        If OutOfWater Then
            Dim EncounterString As String
            Dim Encounter As New EncounterItem
            EncounterString = "You have run out of water. As such, some survivors are not properly hydrated." & vbCrLf

            Encounter.Description = EncounterString
            Encounter.EventType = EventTypes.Alert

            Encounters.Add(Encounter)
        End If

        If HoursLeft = 2 Then
            Dim EncounterString As String
            Dim Encounter As New EncounterItem
            EncounterString = "Packs of hungry undead are gathering around town. You have less than an hour to prepare." & vbCrLf

            Encounter.Description = EncounterString
            Encounter.EventType = EventTypes.Alert

            Encounters.Add(Encounter)
        End If

        If OddTurn Then
            Dim Peep As Person = GenerateNewPerson()
            Survivors.Add(Peep)

            Dim EncounterString As String
            Dim Encounter As New EncounterItem
            EncounterString = Peep.Name & " has found their way to the safety of the Church and joined the survivors. " & vbCrLf

            Encounter.Description = EncounterString
            Encounter.EventType = EventTypes.Alert

            Encounters.Add(Encounter)
        End If

        lb_Encounters.DataSource = Nothing
        lb_Encounters.DisplayMember = "GetDescription"
        lb_Encounters.DataSource = Encounters

        If lb_Encounters.Items.Count > 0 Then
            lb_Encounters.SelectedIndex = 0
        Else
            HoursLeft -= 1
            ZombieMass += 2
            Me.Dispose()
            frmMain.Focus()
        End If
    End Sub

    Private Sub RaidingParty()
        Dim EncounterString As String = ""
        Dim Encounter As New EncounterItem
        Encounter.Building = New BuildingInfo
        Encounter.Building.People = New Generic.List(Of Person)
        Encounter.Building.People = Survivors

        If IsNight() Then
            Dim zChance As Integer = ZombieChance()
            If Rnd.Next(1, 100) <= 45 And Encounter.Building.People.Count > 0 Then
                EncounterString = "Zombies have attacked a group of survivors outside during the night."
                Encounter.EventType = EventTypes.Attacked_Outside
            End If
        ElseIf FinalHour() And Encounter.Building.People.Count > 0 Then
            EncounterString = "In a final display of frenzied hunger, a horde of zombies has attacked the raiding party."
            Encounter.EventType = EventTypes.Attacked_Outside
        Else
            If RaidEveryHour = True And Encounter.Building.People.Count > 0 Then
                EncounterString = "The raiding party has ventured out for supplies."
                Encounter.EventType = EventTypes.Raid
            End If
        End If

        If EncounterString.Length > 0 Then
            Encounter.Description = EncounterString
            Encounters.Add(Encounter)
        End If

    End Sub

    Private Sub btn_Done_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Done.Click
        HoursLeft -= 1
        ZombieMass += 2
        NightAssaultSuccess = False
        Me.Dispose()
        frmMain.Focus()
    End Sub

    Private Sub ZombieAttacks()
        Dim NumberOfAttacks As Integer
        Dim BuildingRanks As New Generic.List(Of BuildingInfo)

        NumberOfAttacks = ZombieParty() / 5
        If FinalHour() Then NumberOfAttacks = 6

        Dim Building As BuildingInfo
        Dim bControl As Control

        Dim EncounterString As String = ""

        For Each bControl In frmMain.pn_Property.Controls
            Building = bControl.Tag

            If Building.Secured = True Then
                Building.AttackChance = Rnd.Next(1, 5) + (Building.LastAttack * 3) + Building.People.Count * 2
                BuildingRanks.Add(Building)
            End If
        Next

        BuildingRanks = SortHighestChance(BuildingRanks)

        Dim i As Integer
        For i = 0 To (NumberOfAttacks - 1)
            Dim Encounter As New EncounterItem
            EncounterString = "The " & BuildingRanks(i).Name & " is under attack by a group of zombies."

            BuildingRanks(i).LastAttack = 0

            Encounter.Description = EncounterString
            Encounter.EventType = EventTypes.Attacked_Building
            Encounter.Building = BuildingRanks(i)

            Encounters.Add(Encounter)
            If i = (BuildingRanks.Count - 1) Then Exit For
        Next

    End Sub

    Private Function SortHighestChance(ByVal Buildings As Generic.List(Of BuildingInfo)) As Generic.List(Of BuildingInfo)
        Dim tempBuilding As New BuildingInfo

        Dim i As Integer, x As Integer
        For i = 0 To Buildings.Count - 1
            For x = i + 1 To Buildings.Count - 1
                If Buildings(i).AttackChance < Buildings(x).AttackChance Then
                    tempBuilding = Buildings(i)
                    Buildings(i) = Buildings(x)
                    Buildings(x) = tempBuilding
                End If
            Next
        Next

        Return Buildings
    End Function

    Private Sub SecureBuildings()
        Dim Building As BuildingInfo
        Dim bControl As Control

        Dim EncounterString As String = ""
        For Each bControl In frmMain.pn_Property.Controls
            EncounterString = ""
            Building = bControl.Tag
            Building.LastAttack += 1

            If Building.Secured = False And Building.People.Count > 0 Then
                EncounterString = "The survivors"
                If Building.People.Count = 1 Then
                    'EncounterString &= " is attempting to secure the " & Building.Name & "."
                    EncounterString &= " are attempting to secure the " & Building.Name & "."
                Else
                    EncounterString &= " are attempting to secure the " & Building.Name & "."
                End If
            End If

            If EncounterString.Length > 0 Then
                Dim Encounter As New EncounterItem
                Encounter.Description = EncounterString
                Encounter.EventType = EventTypes.Secure_Building
                Encounter.Building = Building

                Encounters.Add(Encounter)
            End If
        Next

    End Sub

    Private Sub btn_PlayEncounter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_PlayEncounter.Click
        If lb_Encounters.SelectedItem IsNot Nothing Then
            If lb_Encounters.SelectedItem.Eventtype = EventTypes.Alert Then
                SelectedEncounter = lb_Encounters.SelectedItem

                tb_Results.Text &= SelectedEncounter.Description

                Encounters.Remove(SelectedEncounter)
                SelectedEncounter = Nothing

                lb_Encounters.DataSource = Nothing
                lb_Encounters.DisplayMember = "GetDescription"
                lb_Encounters.DataSource = Encounters
            ElseIf lb_Encounters.SelectedItem.Played = False Then
                SelectedEncounter = lb_Encounters.SelectedItem
                frmEncounter.ShowDialog()
                SelectedEncounter.Played = True
                SelectedEncounter.Description = SelectedEncounter.ResolvedDescription
                tb_Results.Text &= SelectedEncounter.Description & vbCrLf

                Encounters.Remove(SelectedEncounter)
                SelectedEncounter = Nothing

                lb_Encounters.DataSource = Nothing
                lb_Encounters.DisplayMember = "GetDescription"
                lb_Encounters.DataSource = Encounters
            Else
                MsgBox("This encounter has already been resolved.")
            End If
        End If

        If Encounters.Count = 0 Then
            btn_PlayEncounter.Enabled = False
            btn_Done.Enabled = True
            btn_Done.Focus()
        End If

        Me.Focus()
    End Sub
End Class