' Zafehouse
' V1.0
'   -Initial release
' V1.1
'   -Fixed a bug in the raiding code related to weapon generation that would cause a critical error
' V1.2
'   -Clarified help rules on buildings and resources
'   -Reduced the amount of meds found in a raid from 4 to 3
'   -Fixed the "Hours since..." label on the GUI so its value is never hidden
'   -Pressing "~" while a person is selected will heal them
' V1.3
'   -Minor changes to the win text and Win/Lose window
'   -When a building is selected, focus will change to the list of people in it
'   -Message "Weapon is not a firearm" is now suppressed
'   -Fixed a typo "scavanged" -> "scavenged"
'   -Changed reinforcement button text, clearer and includes reinforcement cost
'   -Fixed a bug that would allow unlimited survivors to hold up in a building
' V1.4
'   -Fixed a bug with Sharp Eye perk that would stop it from properly calculating the bonus
'   -Fixed a bug that allowed survivors to whip with their weapon from inside a fortified building
' V1.5
'   -Major patch: Game more difficult, buildings are a lot more important, raiding made more reliable, encounters are faster,
'   game is shorter, mass attack added to end-game, more shortcuts, score more consistent, House is now Church and produces survivors,
'   new perk "Home advantage".
'
'   -Encounters now tick their events automatically. Next round button changed to instant resolution button
'   -Fortification levels of buildings shown with #s on the building GUI
'   -Pressing "0" unloads ammo from weapon of selected survivor
'   -Pressing "Shift" quick equips - selects best weapon and gives it to selected survivor
'   -Pressing "Ctrl" quick removes weapon from selected survivor
'   -Changed raid chances (1-70, 71-90, 91-100) (70%, 20%, 10%). This should result in raiders getting
'   what they want a lot more often
'   -Changed raid priorities (ammo & supplies, water & medicine) to provide better synergy
'   -Increased the amount of zombies encountered outside during the night by 50-100%
'   -Increased the amount of zombies encountered during a raid by 33%
'   -Chance to be attacked outside during the night changed from ZMI to fixed 45% chance
'   -ZombieMassMinimum variable added, increased minimum ZombieMass from 12 to 16
'   -Reduced number of hours from 72 to 60.
'   -New scoring formula: 
'       50 per survivor, 100 per building, 2 per survivor hour, 1 per zombie killed
'       -25 per survivor killed, -35 per survivor turned, -5 per alive survivor infected   
'       If a survivor is turned, they are removed from the survivor killed count
'       If the game is lost, all survivors still alive are added to survivors lost instead
'   -Added zombie mass attack during final hour. ZombieParty for outside attack determined by the number of
'   buildings held. More buildings equals less zombies.
'   -Edited some descriptive text for Attacked_Outside and fixed a typo with the Attacked_Outside resolution text
'   -Most building resource counts have been increased, and in most cases doubled: Factory from 3 to 5 ammo,
'   warehouse from 3 to 5 supplies and store from 2 to 4 water. Hospital remains at 2 med kits. This should 
'   make them more attractive to hold. Subsequently, resources from raiding have been reduced: Supplies from 12 to 8,
'   ammo from 12 to 4, water from 10 to 4 and meds from 3 to 1.  
'   -Added RaidBonus_x and BuildingBonus_x variables. All resource bonuses are controlled from Game.vb
'   -Raid weights changed: weapons > people, ammo = supplies, water > meds
'   -Starting resources reduced: Water from 22 to 16, supplies from 10 to 5
'   -Bite chance increased from 50 to 60 percent
'   -Grizzled perk bite chance reduction increased from 5 to 10%, Sharp Eye percent bonus increased from 1 to 2%
'   -Fixed a bug that would report infected survivors incorrectly during Win/Lose screen
'   -Survivors wielding weapons with no ammo now have the same chance to be bitten as a survivor with a melee weapon (50%)
'   -Added Special bonuses (disabled for now):
'       Secure all buildings - gain +1 production to water, ammo, supplies or meds at random
'   -Survivors gain perks at levels 8, 16 and 24, down from 9, 18 and 27.
'   -Player starts with one additional survivor, armed with a bat
'   -House renamed Church, attracts one survivor every other turn
'   -Help/main menu screen resized
'   -Added new level 3 perk: "Home advantage". Reduces the number of zombies during a building attack by 1, stacks
'   -Added more descriptive barricade info during combat
'
' V1.6
'   -Fixed a potential bug with Ammo conservation talent in the combat and combat resolution code
'   -Added online score functionality
'   -Added website link to Help screen
'   -Added Deadshed.dll and Core.dll in preparation for V2.0
'
' V1.7
'   -Removed Deadshed.dll, now separate game
'   -Kept Core.dll for online upload
'   -Fix a few typos
'   -Fixed a bug that would prevent the Home Advantage perk from working correctly (Thanks Coded One)
'
' V1.8
'   -Fixed score upload problem (not code-related) (Thanks Banjo)
'   -Separated weapons and survivors in the raid priority dialogue (Thanks Banjo)
'   -Fixed a bug that prevented survivors from having a chance to be injured when found in buildings (Thanks kronos)
'   -Added support for custom names:
'       To use custom names, open or create a file called "names.txt" in the same directory as Zafehouse.exe
'       Then add names, one line at a time, to the file. Save it, and next time the game loads, it will
'       draw from the file to generate new names.
'
'       The game will randomly select a name from the file until it runs out of choices. At this point it will
'       refer back to the internal list.
'
' -----------------------------------------------------
'
' V2.0 (** means implemented already)
' random events - infection, sickness, boons
' play out encounters in buildings and raids (deadshed)
' special items to use for events
' occupations
'   doctor - can heal significant wounds
'   cop - can use better weapons
'   civilian - nothing
'   priest - reduce fear effects
'   
' fixed number of survivors - yes!
' goals
' grenades
' zombie culling as raid priority
' hours alive + zombies killed
' ** weapon assignment shortcuts (equip if you have it)
' ** barricade state shown graphically
' shorter game, more decisions per hour
' ** better round management - less clicks
' ** less clicky in general?

' _overhaul notes_
' 15 survivors - if some die, small chance to get more
' create groups?
' clear building, search room by room
' keep universal ammo
' courage/moral
' customisable names via XML
' unlimited mode
' global survivor list
' complex infections
' more weapon types
' more types of medicine
' more types of ammo?
' maybe less survivors (7-8)
' keep couple hit system (no health bars)
' hold up in one building, but can scavenge from multiple (set primary building)
' head shots, body shots - better guns + to chance for head shot
' after four shots, will go down on fourth (depending on how close, report different body part)
' seasoned after one combat, until then, will have a chance to miss
' control hospital, get better treatment, otherwise will stay injured (or take longer to heal)
' random events
' ON THE MOVE

Imports Core

Public Class frmMain

    Private SelectedBuilding As Control = Church


    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text = "Zafehouse v" & Version

        frmHelp.ShowDialog()

        ' set up random name generator, few other things. Located in Game.vb
        Initialise()

        ' set up listboxes to properly display names
        lb_People.DisplayMember = "GetListState"
        lb_PeopleInBuilding.DisplayMember = "GetListState"
        cb_Weapons.DisplayMember = "GetName"

        ' set up and randomly place buildings and create initial survivors
        GenerateProperty()
        RefreshSurvivorsList()

        ' these four commands set up the GUI for water, barricades, ammo and medikits
        InitialiseWater()
        InitialiseAmmo()
        InitialiseMeds()
        InitialiseSupplies()

        ' refreshes the value of the above
        RefreshGeneralInfo()

        ' updates the GUI date, time and hours left
        DoDateTime()

        ' select the church as our initial building so nothing wigs out after load
        Church.Select()

        ' set up initial weapons
        RefreshWeaponList()

        ' put focus on the list of survivors outside
        lb_People.Focus()

        ' some debug flags for checking the win/lose window
        'GameWin = True
        'frmWinLose.ShowDialog()

    End Sub

    ' called every time to refresh resource counts
    Private Sub RefreshGeneralInfo()

        UpdateWater()
        UpdateAmmo()
        UpdateMeds()
        UpdateSupplies()
    End Sub

    ' not really a refresh, more of an initialise for the survivor list
    Private Sub RefreshSurvivorsList()
        lb_People.DataSource = Nothing

        Dim i As Integer
        For i = 0 To 3
            Dim Peep As Person = GenerateNewPerson()
            If i <= 1 Then
                Peep.Weapon = Bat()
            Else
                Peep.Weapon = Pistol()
                Peep.Ammo = 3
            End If
            Survivors.Add(Peep)
        Next

        ' don't forget to associate the survivors list with the lb_People listbox
        ' if you want to alter/remove/add survivors, do it to the Survivors collection
        lb_People.DataSource = Survivors
    End Sub

    ' same as above, but for weapons
    Private Sub RefreshWeaponList()
        cb_Weapons.DataSource = Nothing

        Weapons.Add(Fists())
        Weapons.Add(Bat())
        'Weapons.Add(Pistol())
        'Weapons.Add(Pistol())

        cb_Weapons.DataSource = Weapons
    End Sub

    ' generates the buildings of the town. layout is random, just to make each game
    ' feel more "different"
    Private Sub GenerateProperty()

        ' we specify the church's stats, as it always appears in the same location
        Dim ChurchInfo As New BuildingInfo
        With ChurchInfo
            .Name = "Church"
            .Size = 2
            .AttackChance = 0
            .Reinforcement = 10
            .Secured = True

            .People = New Generic.List(Of Person)
        End With

        Church.Tag = ChurchInfo
        Church.ForeColor = Color.Blue

        Dim i As Integer

        ' randomly size the buildings to add to "difference"
        For i = 1 To Buildings
            Dim Building As New RadioButton
            Dim Height As Integer = RND.Next(70, 110)
            Dim Width As Integer = RND.Next(80, 105)

            ' the commented code below was a concept a played with for the first few builds
            ' buildings would have different capacities based on their size. kind of neat on
            ' paper, but screwed up balance. didn't have time to playtest, so cut it out

            Dim BuildInfo As New BuildingInfo
            '   Select Case Width
            '       Case Is < 80
            '           BuildInfo.Size = 3
            '       Case Is <= 95
            '           BuildInfo.Size = 4
            '   End Select
            BuildInfo.Size = 3

            ' mansion is special, as it can hold 6 people and has fixed dimensions
            If BuildingNames(i) = "Mansion" Then
                BuildInfo.Size = 6
                Height = 120
                Width = 100
            End If

            Building.Name = BuildingNames(i)
            Building.Text = Building.Name
            Building.ForeColor = Color.Red
            BuildInfo.Name = Building.Name
            BuildInfo.Reinforcement = 5
            BuildInfo.People = New Generic.List(Of Person)

            Building.Appearance = Appearance.Button
            Building.FlatStyle = FlatStyle.Flat
            Building.TextAlign = ContentAlignment.MiddleCenter
            Building.AutoSize = False

            Building.Width = Width
            Building.Height = Height

            Building.BackColor = Color.White

            ' because we're creating the building at runtime, we need to add a handler
            ' for a click programmatically. This also allows us to use the same
            ' routine for all buildings.
            AddHandler Building.Click, AddressOf BuildingClick

            Building.Tag = BuildInfo
            pn_Property.Controls.Add(Building)

            ' our random building placement code
            ' A rectangle with the bounds of the control is made, then inflated to give us
            ' some breathing room around the buildings and to prevent them from
            ' overlapping. some failsafe code is in there to prevent the game
            ' from freezing if the location/size doesn't fit anywhere.

            Dim iterations As Integer
            Do
                Dim x As Integer = RND.Next(25, pn_Property.Width)
                Dim y As Integer = RND.Next(25, pn_Property.Height)

                Building.Left = Math.Abs(x - (Width))
                Building.Top = Math.Abs(y - (Height))

                If notIntersect(Building) Then Exit Do
                iterations += 1

                If iterations >= 100 Then
                    pn_Property.Controls.Remove(Building)
                    i -= 1
                    Exit Do
                End If
            Loop
        Next

        ' make sure the church is attached to the rest of the building click code
        AddHandler Church.Click, AddressOf BuildingClick
    End Sub

    ' handles clicking on a building
    Public Sub BuildingClick(ByVal sender As Object, ByVal e As System.EventArgs)
        For Each control As Control In pn_Property.Controls
            control.BackColor = Color.White
        Next

        If sender.checked Then
            sender.backcolor = Color.Orange
        End If

        Dim bState As String = ""
        Select Case sender.tag.Secured
            Case True
                bState = " (Secured)"
            Case False
                bState = " (Unsecured)"
        End Select

        ' unused overrun flag. originally buildings retaken by zombies would be
        ' forever lost. this seemed a little silly, so I made them unsecured
        ' instead.
        If sender.tag.Overrun = True Then bState = " (Overrun)"

        lbl_BuildingName.Text = sender.tag.Name & bState
        SelectedBuilding = sender

        RefreshBuildingInfo()

        ' if the building has people in it, assign focus to the list box of people in the building
        If SelectedBuilding.Tag.People.Count > 0 Then
            lb_PeopleInBuilding.Focus()
            lb_PeopleInBuilding.SelectedIndex = 0
        End If
    End Sub

    ' should be used whenever anything about any building changes, especially the builing currently selected
    Public Sub RefreshBuildingInfo()
        Dim bInfo As BuildingInfo = SelectedBuilding.Tag
        lbl_Reinforcement.Text = "Reinforcement: "

        Select Case bInfo.Reinforcement
            Case Is <= 0
                lbl_Reinforcement.Text &= "None"
            Case Is <= 5
                lbl_Reinforcement.Text &= "Weak"
            Case Is <= 10
                lbl_Reinforcement.Text &= "Light"
            Case Is <= 15
                lbl_Reinforcement.Text &= "Medium"
            Case Is <= 20
                lbl_Reinforcement.Text &= "Heavy"
            Case Is < 25
                lbl_Reinforcement.Text &= "Strong"
            Case Is >= 25
                lbl_Reinforcement.Text &= "Fortified"
        End Select

        lbl_LastAttack.Text = "Hours since last attack: " & bInfo.LastAttack

        lb_PeopleInBuilding.DataSource = Nothing
        lb_PeopleInBuilding.DisplayMember = "GetListState"
        lb_PeopleInBuilding.DataSource = bInfo.People

        Dim checkBuilding As Control

        ' here we iterate through all the buildings, to make sure they're displaying the right
        ' survivor count in their Text property.

        For Each checkBuilding In pn_Property.Controls
            Dim fortStrength As String = ""
            Dim Stars() As String = {"#", "##", "###", "####", "#####", "######"}
            bInfo = checkBuilding.Tag

            If bInfo.People.Count > 0 Then
                checkBuilding.Text = bInfo.Name & " (" & bInfo.People.Count & ")"
            Else
                checkBuilding.Text = bInfo.Name
            End If

            If bInfo.Reinforcement <= 0 Then
                fortStrength = ""
            Else
                fortStrength = "(" & Stars((bInfo.Reinforcement / 5)) & ")"
            End If

            checkBuilding.Text &= vbCrLf & fortStrength

            If bInfo.Secured = True Then
                If checkBuilding Is SelectedBuilding Then lbl_BuildingName.Text = bInfo.Name & " (Secured)"
                checkBuilding.ForeColor = Color.Blue
            Else
                If checkBuilding Is SelectedBuilding Then lbl_BuildingName.Text = bInfo.Name & " (Unsecured)"
                checkBuilding.ForeColor = Color.Red
            End If
        Next
    End Sub

    ' part of the random building placement code. makes sure we don't place buildings
    ' on top of each other. we grab the control bounds and inflate it to give
    ' ourselves some breathing room

    Public Function notIntersect(ByVal control As Control) As Boolean
        For Each testControl As Control In pn_Property.Controls
            Dim testBounds As Rectangle = testControl.Bounds
            testBounds.Inflate(15, 15)
            If control.Bounds.IntersectsWith(testBounds) And control IsNot testControl Then
                Return False
            End If
        Next

        Return True
    End Function

    Private Sub btn_Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Exit.Click
        Dim result As DialogResult = MsgBox("Are you sure?", MsgBoxStyle.YesNo)
        If result = Windows.Forms.DialogResult.Yes Then
            Application.Exit()
        End If
    End Sub

    ' should be called whenever the status of a survivor changes.

    Private Sub RefreshPeople()
        lb_People.DataSource = Nothing
        lb_PeopleInBuilding.DataSource = Nothing

        lb_People.ValueMember = "GetListState"
        lb_People.DisplayMember = "GetListState"
        lb_People.DataSource = Survivors

        lb_PeopleInBuilding.ValueMember = "GetListState"
        lb_PeopleInBuilding.DisplayMember = "GetListState"
        lb_PeopleInBuilding.DataSource = SelectedBuilding.Tag.People
    End Sub

    Private Sub RefreshWeapons()
        cb_Weapons.DataSource = Nothing
        cb_Weapons.DataSource = Weapons
        cb_Weapons.DisplayMember = "GetName"
        cb_Weapons.SelectedIndex = 0
    End Sub

    Private Sub btn_AddSurvivor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_AddSurvivor.Click
        AddSurvivorToBuilding()
    End Sub

    Private Sub AddSurvivorToBuilding()

        ' this routine adds a survivor to the currently selected building
        Dim StopAction As Boolean

        If lb_People.SelectedItem IsNot Nothing Then
            If SelectedBuilding.Tag.Overrun Then
                MsgBox("This building has been overrun! You must abandon it.", MsgBoxStyle.OkOnly)
                StopAction = True
            ElseIf SelectedBuilding.Tag.Secured = False And lb_PeopleInBuilding.Items.Count = 0 Then
                Dim result As DialogResult = _
                MsgBox("This building is unsecured. Would you like to try and clear it?", MsgBoxStyle.YesNo)

                If result = Windows.Forms.DialogResult.No Then
                    StopAction = True
                End If
            End If
        Else
            StopAction = True
        End If

        If StopAction = False Then
            If lb_PeopleInBuilding.Items.Count >= SelectedBuilding.Tag.Size Then
                MsgBox("This building is full.")
            Else

                SelectedBuilding.Tag.People.Add(lb_People.SelectedItem)
                Survivors.Remove(lb_People.SelectedItem)

                SelectedBuilding.Text = SelectedBuilding.Tag.Name
                If (SelectedBuilding.Tag.People.Count) > 0 Then
                    SelectedBuilding.Text &= " (" & SelectedBuilding.Tag.People.Count & ")"
                End If

                RefreshPeople()
                RefreshBuildingInfo()
                If lb_People.Items.Count > 0 Then lb_People.SelectedIndex = 0
            End If
        End If
    End Sub

    Private Sub btn_MoveBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_MoveBack.Click
        MoveSurvivorOutside()
    End Sub

    Private Sub MoveSurvivorOutside()
        If lb_PeopleInBuilding.SelectedItem IsNot Nothing Then

            Survivors.Add(lb_PeopleInBuilding.SelectedItem)
            SelectedBuilding.Tag.People.Remove(lb_PeopleInBuilding.SelectedItem)

            SelectedBuilding.Text = SelectedBuilding.Tag.Name

            If (SelectedBuilding.Tag.People.Count) > 0 Then
                SelectedBuilding.Text &= " (" & SelectedBuilding.Tag.People.Count & ")"
            End If
        End If

        RefreshPeople()
        RefreshBuildingInfo()
        If lb_PeopleInBuilding.Items.Count > 0 Then lb_PeopleInBuilding.SelectedIndex = 0
    End Sub

    Private Sub btn_Equip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Equip.Click
        Dim SelectedPerson As Person = Nothing
        Dim Outside As Boolean

        If lb_People.SelectedItem IsNot Nothing Then
            SelectedPerson = lb_People.SelectedItem
            Outside = True
        ElseIf lb_PeopleInBuilding.SelectedItem IsNot Nothing Then
            SelectedPerson = lb_PeopleInBuilding.SelectedItem
            Outside = False
        End If

        If cb_Weapons.SelectedItem IsNot Nothing And SelectedPerson IsNot Nothing Then
            If cb_Weapons.SelectedItem.Name = "Fists" Then
                If SelectedPerson.Weapon.Name = "Fists" Then
                Else
                    Weapons.Add(SelectedPerson.Weapon)
                    Ammo += SelectedPerson.Ammo
                    SelectedPerson.Ammo = 0

                    SelectedPerson.Weapon = Fists()
                End If
            Else


                If SelectedPerson.Weapon.Name = "Fists" Then
                    SelectedPerson.Weapon = cb_Weapons.SelectedItem
                    Weapons.Remove(cb_Weapons.SelectedItem)
                Else
                    Dim tempWeapon As WeaponType = SelectedPerson.Weapon
                    SelectedPerson.Weapon = cb_Weapons.SelectedItem
                    Weapons.Remove(cb_Weapons.SelectedItem)
                    Weapons.Add(tempWeapon)
                End If

                Ammo += SelectedPerson.Ammo
                SelectedPerson.Ammo = 0

            End If

            RefreshPeople()
            RefreshWeapons()
            RefreshGeneralInfo()

            If Outside Then
                lb_People.SelectedItem = SelectedPerson
            Else
                lb_PeopleInBuilding.SelectedItem = SelectedPerson
            End If
        End If

    End Sub

    Private Sub btn_Unequip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Unequip.Click
        RemoveWeapon()
    End Sub

    Private Sub lb_People_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lb_People.DoubleClick
        AddSurvivorToBuilding()
    End Sub

    Private Sub LoadAmmo(ByVal amount As Integer)
        Dim SelectedPerson As Person = Nothing
        Dim Outside As Boolean

        If lb_People.SelectedItem IsNot Nothing Then
            SelectedPerson = lb_People.SelectedItem
            Outside = True
        ElseIf lb_PeopleInBuilding.SelectedItem IsNot Nothing Then
            SelectedPerson = lb_PeopleInBuilding.SelectedItem
            Outside = False
        End If

        If SelectedPerson IsNot Nothing Then
            Dim Peep As Person = SelectedPerson

            Dim AmmoToGive As Integer = amount * Peep.Weapon.AmmoNeed

            If (Ammo + Peep.Ammo) >= AmmoToGive And Peep.Weapon.IsMelee = False Then
                Ammo += Peep.Ammo
                Ammo -= AmmoToGive
                Peep.Ammo = AmmoToGive
                RefreshPeople()
            Else
                If Peep.Weapon.IsMelee = False Then
                    MsgBox("Insufficient ammo to perform a loadout.")
                Else
                    'MsgBox("Weapon is not a firearm.")
                End If
            End If

            RefreshGeneralInfo()

            If Outside Then
                lb_People.SelectedItem = SelectedPerson
            Else
                lb_PeopleInBuilding.SelectedItem = SelectedPerson
            End If
        End If

    End Sub

    Private Sub GiveBestWeapon()

        Dim SelectedItem As Person = Nothing, Outside As Boolean
        If lb_People.SelectedItem IsNot Nothing Then
            SelectedItem = lb_People.SelectedItem
            Outside = True
        ElseIf lb_PeopleInBuilding.SelectedItem IsNot Nothing Then
            SelectedItem = lb_PeopleInBuilding.SelectedItem
            Outside = False
        End If

        Dim PersonToEquip As Person = SelectedItem
        Dim Weapon As WeaponType = Fists()
        Dim Found As Boolean = False

        For Each Weapon In Weapons
            If Weapon.Name = "Shotgun" Then
                Found = True
                Exit For
            End If
        Next

        If Found = False Then
            For Each Weapon In Weapons
                If Weapon.Name = "Rifle" Then
                    Found = True
                    Exit For
                End If
            Next
        End If

        If Found = False Then
            For Each Weapon In Weapons
                If Weapon.Name = "Pistol" Then
                    Found = True
                    Exit For
                End If
            Next
        End If

        If Found = False Then
            For Each Weapon In Weapons
                If Weapon.Name = "Machete" Then
                    Found = True
                    Exit For
                End If
            Next
        End If

        If Found = False Then
            For Each Weapon In Weapons
                If Weapon.Name = "Baseball bat" Then
                    Found = True
                    Exit For
                End If
            Next
        End If

        If Found Then
            If PersonToEquip.Weapon.Name <> "Fists" Then
                Weapons.Add(PersonToEquip.Weapon)
                Ammo += PersonToEquip.Ammo
                PersonToEquip.Ammo = 0
            End If

            PersonToEquip.Weapon = Weapon
            Weapons.Remove(Weapon)

            RefreshPeople()
            RefreshWeapons()
            RefreshGeneralInfo()
        End If

        SelectedItem = PersonToEquip
        If Outside Then
            lb_People.SelectedItem = SelectedItem
        Else
            lb_PeopleInBuilding.SelectedItem = SelectedItem
        End If
    End Sub

    Private Sub lb_People_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles lb_People.KeyDown
        Dim enew As New System.EventArgs
        Select Case e.KeyCode
            Case Keys.D1
                LoadAmmo(1)
            Case Keys.D2
                LoadAmmo(2)
            Case Keys.D3
                LoadAmmo(3)
            Case Keys.D0
                LoadAmmo(0)
            Case Keys.ShiftKey
                GiveBestWeapon()
            Case Keys.ControlKey
                RemoveWeapon()
            Case Keys.Oemtilde
                DoHeal()
        End Select
    End Sub

    Private Sub RemoveWeapon()
        Dim SelectedPerson As Person = Nothing
        Dim SelectedIndex As Integer
        Dim Outside As Boolean

        If lb_People.SelectedItem IsNot Nothing Then
            SelectedPerson = lb_People.SelectedItem
            SelectedIndex = lb_People.SelectedIndex
            Outside = True
        ElseIf lb_PeopleInBuilding.SelectedItem IsNot Nothing Then
            SelectedPerson = lb_PeopleInBuilding.SelectedItem
            SelectedIndex = lb_PeopleInBuilding.SelectedIndex
            Outside = False
        End If

        If SelectedPerson IsNot Nothing Then
            If SelectedPerson.Weapon.Name <> "Fists" Then
                Dim tempWeapon As WeaponType = SelectedPerson.Weapon
                SelectedPerson.Weapon = Fists()
                Weapons.Add(tempWeapon)
            End If

            Ammo += SelectedPerson.Ammo
            SelectedPerson.Ammo = 0

            RefreshPeople()
            RefreshWeapons()
            RefreshGeneralInfo()

            If Outside Then
                lb_People.SelectedItem = SelectedPerson
                lb_People.SelectedIndex = SelectedIndex
            Else
                lb_PeopleInBuilding.SelectedItem = SelectedPerson
                lb_PeopleInBuilding.SelectedIndex = SelectedIndex
            End If
        End If
    End Sub
    Private Sub lb_People_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lb_People.SelectedIndexChanged
        If lb_People.SelectedItem IsNot Nothing Then
            lb_PeopleInBuilding.SelectedIndex = -1
            lbl_PersonName.Text = lb_People.SelectedItem.Name
            lbl_Status.Text = "Status: " & TranslateStatus(lb_People.SelectedItem)
            btn_Treat.Enabled = Not (TranslateStatus(lb_People.SelectedItem).Contains("Healthy"))
        Else
            lbl_Status.Text = "Status: N/A"
            lbl_PersonName.Text = "Select a survivor"
            btn_Treat.Enabled = False
        End If

    End Sub

    Private Function TranslateStatus(ByVal Peep As Person) As String
        Dim State As String = ""

        With Peep
            Select Case Peep.Wounds
                Case 0
                    State = "Healthy"
                Case 1
                    State = "Injured"
                Case 2
                    State = "Maimed"
                Case Is > 2
                    If Peep.Promo_Lucky Then
                        State = "Deathly"
                    Else
                        State = "Dead"
                    End If
            End Select

            If Peep.Starved Then
                State &= ", Thirsty"
            End If

            ' not used
            If Peep.Tired Then
                State &= ", Tired"
            End If

            If Peep.Infected Then
                State &= ", Fevered"
            End If
        End With

        Return State
    End Function

    ' does all our water stuff. basically, if four hours have passed, attempt to drink
    ' if not enough water, mark them as thirsty.
    ' this is executed every hour, so if the player finds water and has thirsty people
    ' it'll make them drink it regardless of hour much time has passed
    Private Function DrinkWater(ByVal peep As Person) As Boolean
        If TimeToDrink = 4 Or peep.Starved Then
            If Water > 0 Then
                peep.Starved = False
                Water -= 1
                Return False
            Else
                peep.Starved = True
                Return True
            End If
        End If

        Return False
    End Function

    ' this is called during the advance hour routine. does all our hourly survivor stuff, like
    ' drinking water and checking experience levels for perks
    Private Sub DoSurvivorsEvents()
        Dim bInfo As BuildingInfo, control As Control
        Dim Survivor As New Person

        TimeToDrink += 1

        For Each Survivor In Survivors
            Survivor.Experience += 1
            OutOfWater = DrinkWater(Survivor)
            DoPromotion(Survivor)
        Next

        For Each control In pn_Property.Controls
            bInfo = control.Tag
            For Each Survivor In bInfo.People
                Survivor.Experience += 1
                OutOfWater = DrinkWater(Survivor)
                DoPromotion(Survivor)
            Next
        Next

        ' reset our "has four hours passed?" counter
        If TimeToDrink = 4 Then TimeToDrink = 0

    End Sub

    ' called by DoSurvivorEvents, checks the survivors hours alive (.Experience) and if
    ' it's at a certain level (9, 18 and 27 as of v1.4) gives them the promotion window
    Private Sub DoPromotion(ByVal Survivor As Person)
        Dim sLevel As SurvivorLevels = Survivor.Experience
        Select Case sLevel
            Case SurvivorLevels.Level1, SurvivorLevels.Level2, SurvivorLevels.Level3
                SurvivorToPromote = Survivor
                frmPromote.ShowDialog()
        End Select
        SurvivorToPromote = Nothing
    End Sub

    ' I was lazy, so we just kill and restart the program to "simulate" a new game button
    Public Sub StartNewGame()
        Application.Restart()
    End Sub

    ' THIS DOESN'T WORK, DO NOT USE IT
    Public Sub StartNewGame2()
        Survivors.Clear()
        Weapons.Clear()

        For Each control As RadioButton In pn_Property.Controls
            control.Visible = False
            pn_Property.Controls.Remove(control)
            control.Dispose()
        Next

        Dim House As New RadioButton
        House.Name = "House"
        House.Width = 80
        House.Height = 72
        House.Left = 168
        House.Top = 184

        House.Show()

        pn_Property.Controls.Add(House)

        SurvivorsLost = 0
        ZombiesKilled = 0

        GameWin = False
        GameLose = False

        Water = 22
        Supplies = 10
        Ammo = 3
        Medicine = 2

        NightAssaultSuccess = False

        RaidEveryHour = True

        TimeToDrink = 0
        TimeToRestock = 0

        OutOfWater = False

        RaidPriority_Survivors = 1
        RaidPriority_Weapons = 2
        RaidPriority_AmmoSupplies = 3
        RaidPriority_MedicineWater = 4

        HoursLeft = 72

        ZombiesKilled = 0
        SurvivorsLost = 0
        SurvivorsTurned = 0

        ZombieMass = 0

        GenerateProperty()

        RefreshSurvivorsList()
        RefreshGeneralInfo()

        DoDateTime()

        House.Select()

        RefreshWeaponList()
    End Sub

    ' our advance one hour logic
    Private Sub btn_NextHour_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_NextHour.Click

        ' check to make sure the player is raiding if he can. may be bugged, allowing people to raid even if it
        ' is night
        If Survivors.Count = 0 And RaidEveryHour = True And IsNight() = False Then
            Dim result As DialogResult = MsgBox("You've organised a raiding schedule, but no one is in the raiding party." & vbCrLf & vbCrLf & _
            "Are you sure you want to continue?", MsgBoxStyle.YesNo)

            Select Case result
                Case Windows.Forms.DialogResult.Yes
                    RaidEveryHour = False
                Case Else
                    Exit Sub
            End Select
        End If

        DoSurvivorsEvents()

        frmEvents.ShowDialog()

        RaidEveryHour = True

        Dim HasBuildings As Boolean
        Dim Control As Control
        Dim bInfo As BuildingInfo

        ' lose game condition check - does the player hold at least one building?
        For Each Control In pn_Property.Controls
            bInfo = Control.Tag
            HasBuildings = bInfo.Secured
            If HasBuildings = True Then Exit For
        Next

        ' more lose stuff - does the player have at least one survivor?
        If GetTotalSurvivors() = 0 Then
            GameLose = True
            frmWinLose.ShowDialog()
        ElseIf HasBuildings = False Then
            GameLose = True
            SurvivorsLost += Survivors.Count
            frmWinLose.ShowDialog()

            ' win check, lasted 72 hours!
        ElseIf HoursLeft = 0 Then
            GameWin = True
            frmWinLose.ShowDialog()
        Else
            ProcessBuildingBonuses()

            RefreshPeople()
            RefreshWeapons()

            RefreshBuildingInfo()
            RefreshGeneralInfo()
            UpdateWater()

            ' works, but it forces the player to secure buildings early
            'DoSpecialBonuses()
        End If

        If GameWin = False And GameLose = False Then
            GameTime = GameTime.AddHours(1)
            DoDateTime()
            If IsStartNight() Then
                MsgBox("Night has fallen. It's too dark to raid. Survivors should hold up in buildings until dawn (6AM).")
                lbl_Hour.ForeColor = Color.Yellow
                lbl_Hour.BackColor = Color.DarkBlue
            ElseIf IsStartDay() Then
                MsgBox("The sun has risen. Survivors can once again raid for supplies.")
                lbl_Hour.ForeColor = Color.DarkBlue
                lbl_Hour.BackColor = Color.Yellow
            End If
            System.GC.Collect()
            Me.Focus()
        Else
            If DoNewGame = True Then
                StartNewGame()
            Else
                Application.Exit()
            End If
        End If
    End Sub


    Private Sub DoSpecialBonuses()
        If GetBuildingsHeld() = 6 And SpecialBonus_AllBuildingsHeld = False Then
            Dim sBonus As Integer = RND.Next(3)
            Dim sBonusString As String = ""

            Select Case sBonus
                Case 0
                    sBonusString = "The factory will produce more ammo."
                    BuildingBonus_Ammo += 1
                Case 1
                    sBonusString = "The warehouse will produce more barricades."
                    BuildingBonus_Supplies += 1
                Case 2
                    sBonusString = "The hospital will produce more medicines."
                    BuildingBonus_Medicine += 1
                Case 3
                    sBonusString = "The store will produce more water."
                    BuildingBonus_Water += 1
            End Select

            MsgBox("The survivors have managed to secure all the buildings in town. As a reward: " & sBonusString, MsgBoxStyle.OkOnly, "Bonus: All buildings secured!")
            SpecialBonus_AllBuildingsHeld = True
        End If
    End Sub

    Private Sub UpdateWater()
        Dim FillCount As Integer = Water / GetTotalSurvivors()
        Dim RemanderCount As Integer = Water - (FillCount * GetTotalSurvivors())

        Dim i As Integer
        For i = 1 To (3 * 16)
            If i <= FillCount Then
                flp_Water.Controls.Find("WaterBlock" & i, True)(0).BackColor = Color.RoyalBlue
                If i = (3 * 16) Then
                    flp_Water.Controls.Find("WaterBlock" & i, True)(0).BackColor = Color.LightGreen
                End If
            Else
                If RemanderCount > 0 And i = FillCount + 1 Then
                    flp_Water.Controls.Find("WaterBlock" & i, True)(0).BackColor = Color.LightSteelBlue
                Else
                    flp_Water.Controls.Find("WaterBlock" & i, True)(0).BackColor = Color.Beige
                End If
            End If
        Next

        lbl_WaterSupply.Text = "Water: " & Water & " litre(s)"

    End Sub

    Private Sub UpdateAmmo()
        Dim FillCount As Integer = Ammo / 3
        Dim RemanderCount As Integer = Ammo - (FillCount * 3)

        Dim i As Integer
        For i = 1 To (3 * 16)
            If i <= FillCount Then
                flp_Ammo.Controls.Find("AmmoBlock" & i, True)(0).BackColor = Color.Gold
                If i = (3 * 16) Then
                    flp_Ammo.Controls.Find("AmmoBlock" & i, True)(0).BackColor = Color.LightGreen
                End If
            Else
                If RemanderCount > 0 And i = FillCount + 1 Then
                    flp_Ammo.Controls.Find("AmmoBlock" & i, True)(0).BackColor = Color.Yellow
                Else
                    flp_Ammo.Controls.Find("AmmoBlock" & i, True)(0).BackColor = Color.Beige
                End If
            End If
        Next

        lbl_AmmoSupply.Text = "Ammo: " & Ammo & " box(es)"

    End Sub

    Private Sub UpdateMeds()
        Dim FillCount As Integer = Medicine / 2
        Dim RemanderCount As Integer = Medicine - (FillCount * 2)

        Dim i As Integer
        For i = 1 To (2 * 16)
            If i <= FillCount Then
                flp_Meds.Controls.Find("MedsBlock" & i, True)(0).BackColor = Color.Red
                If i = (2 * 16) Then
                    flp_Meds.Controls.Find("MedsBlock" & i, True)(0).BackColor = Color.LightGreen
                End If
            Else
                If RemanderCount > 0 And i = FillCount + 1 Then
                    flp_Meds.Controls.Find("MedsBlock" & i, True)(0).BackColor = Color.Pink
                Else
                    flp_Meds.Controls.Find("MedsBlock" & i, True)(0).BackColor = Color.Beige
                End If
            End If
        Next

        lbl_MedsSupply.Text = "Medicine: " & Medicine & " kit(s)"

    End Sub

    Private Sub UpdateSupplies()
        Dim FillCount As Integer = Supplies / 5
        Dim RemanderCount As Integer = Supplies - (FillCount * 5)

        Dim i As Integer
        For i = 1 To (2 * 22)
            If i <= FillCount Then
                flp_Supplies.Controls.Find("SupplyBlock" & i, True)(0).BackColor = Color.Black
                If i = (2 * 22) Then
                    flp_Supplies.Controls.Find("SupplyBlock" & i, True)(0).BackColor = Color.LightGreen
                End If
            Else
                If RemanderCount > 0 And i = FillCount + 1 Then
                    flp_Supplies.Controls.Find("SupplyBlock" & i, True)(0).BackColor = Color.Gray
                Else
                    flp_Supplies.Controls.Find("SupplyBlock" & i, True)(0).BackColor = Color.Beige
                End If
            End If
        Next

        lbl_BarricadeSupply.Text = "Barricades: " & Supplies & " piece(s)"

    End Sub

    Private Sub InitialiseSupplies()
        Dim i As Integer
        For i = 1 To (2 * 22)
            Dim supplyblock As New Panel
            supplyblock.BackColor = Color.Black
            supplyblock.Name = "SupplyBlock" & i
            supplyblock.BorderStyle = BorderStyle.FixedSingle
            supplyblock.Show()

            supplyblock.Width = 7
            supplyblock.Height = 13

            flp_Supplies.Controls.Add(supplyblock)
        Next

        UpdateSupplies()
    End Sub

    Private Sub InitialiseMeds()
        Dim i As Integer
        For i = 1 To (2 * 16)
            Dim medsblock As New Panel
            medsblock.BackColor = Color.Red
            medsblock.Name = "MedsBlock" & i
            medsblock.BorderStyle = BorderStyle.FixedSingle
            medsblock.Show()

            medsblock.Width = 7
            medsblock.Height = 7

            flp_Meds.Controls.Add(medsblock)
        Next

        UpdateMeds()
    End Sub


    Private Sub InitialiseAmmo()
        Dim i As Integer
        For i = 1 To (3 * 16)
            Dim ammoblock As New Panel
            ammoblock.BackColor = Color.Gold
            ammoblock.Name = "AmmoBlock" & i
            ammoblock.BorderStyle = BorderStyle.FixedSingle
            ammoblock.Show()

            ammoblock.Width = 7
            ammoblock.Height = 13

            flp_Ammo.Controls.Add(ammoblock)
        Next

        UpdateAmmo()
    End Sub

    Private Sub InitialiseWater()
        Dim i As Integer
        For i = 1 To (3 * 16)
            Dim waterblock As New Panel
            waterblock.BackColor = Color.Lavender
            waterblock.Name = "WaterBlock" & i
            waterblock.BorderStyle = BorderStyle.FixedSingle
            waterblock.Show()

            waterblock.Width = 7
            waterblock.Height = 13

            flp_Water.Controls.Add(waterblock)
        Next

        UpdateWater()
    End Sub

    Private Sub DoDateTime()
        lbl_DateTime.Text = GameTime.ToString("MMMM d")
        lbl_Hour.Text = GameTime.ToString("%h:mmtt")
        lbl_HoursLeft.Text = HoursLeft & " hours left"
    End Sub

    Private Sub ProcessBuildingBonuses()
        Dim Control As Control, bInfo As BuildingInfo

        For Each Control In pn_Property.Controls
            bInfo = Control.Tag

            ' if you want to decrease/increase the resources supplied by a secured
            ' building, do it here.
            If bInfo.Secured Then
                Select Case bInfo.Name
                    Case "Church"
                        ' attracts one survivor every other turn, added v1.5
                        ' to make sure the player is made aware, this is handled in vbEvents
                        OddTurn = Not (OddTurn)
                    Case "Factory"
                        Ammo += BuildingBonus_Ammo
                    Case "Hospital"
                        Medicine += BuildingBonus_Medicine
                    Case "Warehouse"
                        Supplies += BuildingBonus_Supplies
                    Case "Store"
                        Water += BuildingBonus_Water
                End Select
            ElseIf bInfo.Secured = False Then
                If bInfo.Name = "Church" Then
                    OddTurn = False
                End If
            End If
        Next
    End Sub

    Private Sub btn_AmmoLoads_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
    btn_1Load.Click, btn_2Load.Click, btn_3Load.Click, btn_AmmoEmpty.Click
        LoadAmmo(sender.tag)
    End Sub

    Private Sub btn_Raid_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Raid.Click
        frmRaid.ShowDialog()
    End Sub

    Private Sub btn_Help_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Help.Click
        frmHelp.btn_Done.Text = "Return to game"
        frmHelp.ShowDialog()
    End Sub

    Private Sub lb_PeopleInBuilding_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles lb_PeopleInBuilding.KeyDown
        Dim enew As New System.EventArgs
        Select Case e.KeyCode
            Case Keys.D1
                LoadAmmo(1)
            Case Keys.D2
                LoadAmmo(2)
            Case Keys.D3
                LoadAmmo(3)
            Case Keys.D0
                LoadAmmo(0)
            Case Keys.ShiftKey
                GiveBestWeapon()
            Case Keys.ControlKey
                RemoveWeapon()
            Case Keys.Oemtilde
                DoHeal()
        End Select
    End Sub

    Private Sub lb_PeopleInBuilding_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lb_PeopleInBuilding.MouseDoubleClick
        MoveSurvivorOutside()
    End Sub

    Private Sub lb_PeopleInBuilding_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lb_PeopleInBuilding.SelectedIndexChanged
        If lb_PeopleInBuilding.SelectedItem IsNot Nothing Then
            lb_People.SelectedIndex = -1
            lbl_PersonName.Text = lb_PeopleInBuilding.SelectedItem.Name
            lbl_Status.Text = "Status: " & TranslateStatus(lb_PeopleInBuilding.SelectedItem)
            btn_Treat.Enabled = Not (TranslateStatus(lb_PeopleInBuilding.SelectedItem).Contains("Healthy"))
        Else
            lbl_Status.Text = "Status: N/A"
            lbl_PersonName.Text = "Select a survivor"
            btn_Treat.Enabled = False
        End If

    End Sub

    Private Sub btn_AllOutside_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_AllOutside.Click
        Dim Control As Control, Building As BuildingInfo, Peep As Person

        For Each Control In pn_Property.Controls
            Building = Control.Tag
            For Each Peep In Building.People
                Survivors.Add(Peep)
            Next
            Building.People.Clear()
        Next

        RefreshBuildingInfo()
        RefreshPeople()

    End Sub

    Private Sub btn_Reinforce_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Reinforce.Click
        If Supplies < 5 Then
            MsgBox("Insufficient supplies to create a proper barracade.")
        ElseIf SelectedBuilding.Tag.Secured = False Then
            MsgBox("You need to secure the building before you can fortify it.")
        Else

            If SelectedBuilding IsNot Nothing Then
                Dim bInfo As BuildingInfo = SelectedBuilding.Tag
                If (bInfo.Reinforcement + 5) <= 25 Then
                    bInfo.Reinforcement += 5
                    Supplies -= 5
                Else
                    Dim Difference As Integer = 25 - bInfo.Reinforcement
                    bInfo.Reinforcement = 25
                    Supplies -= Difference
                End If

                RefreshBuildingInfo()
                RefreshGeneralInfo()
            End If
        End If

    End Sub

    Private Sub btn_Treat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Treat.Click
        DoHeal()
    End Sub

    Private Sub DoHeal()
        Dim SelectedPerson As Person = Nothing
        Dim Outside As Boolean

        If Medicine = 0 Then
            MsgBox("Insufficient medicine to provide treatment.")
        Else
            If lb_People.SelectedItem IsNot Nothing Then
                SelectedPerson = lb_People.SelectedItem
                Outside = True
            ElseIf lb_PeopleInBuilding.SelectedItem IsNot Nothing Then
                SelectedPerson = lb_PeopleInBuilding.SelectedItem
                Outside = False
            End If

            If SelectedPerson IsNot Nothing Then
                If SelectedPerson.Wounds > 0 Then
                    SelectedPerson.Wounds -= 1
                    Medicine -= 1

                    lbl_Status.Text = "Status: " & TranslateStatus(SelectedPerson)
                    btn_Treat.Enabled = Not (TranslateStatus(SelectedPerson).Contains("Healthy"))
                End If
            End If

            RefreshGeneralInfo()
            RefreshPeople()

            If Outside Then
                lb_People.SelectedItem = SelectedPerson
            Else
                lb_PeopleInBuilding.SelectedItem = SelectedPerson
            End If

        End If
    End Sub

    Private Sub lbl_Status_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles lbl_Status.GotFocus
        btn_Equip.Focus()
    End Sub

    Private Sub btn_Discard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Discard.Click
        If cb_Weapons.SelectedItem IsNot Nothing And cb_Weapons.SelectedItem.Name <> "Fists" Then
            Weapons.Remove(cb_Weapons.SelectedItem)
            RefreshWeapons()
        End If
    End Sub

End Class
